GCD and LCM HDU - 4497(素数打表+唯一分解定理)求多少种情况

题目大意: 给你两个数最小公倍数L,最大公约数G,问你有多少有序数组(x,y,z)满足GCD(x,y,z)=G,LCM(x,y,z)=L,首先如果gcd(x,y,z)=G,

思路分析: 当这样的组合存在的时候,求gcd(x,y,z)=1且lcm(x,y,z)=L/G的方法数是等价的。   

那么:令temp=L/G。   

对temp进行素数分解:temp=p1^t1 * p2^t2 * ……* pn^tn。   

因为temp是这三个数的倍数,因而x,y,z的组成形式为:   

x=p1^i1 * p2^i2 *…… * pn^in;   

y=p1^j1 * p2^j2 *…… * pn^jn;   

z=p1^k1 * p2^k2 * …… * pn^kn;   

对于某一个素因子p:           

因为要满足x,y,z的最大公约数为1,即三个数没有共同的素因子,所以min(i,j,k)=0。           

又因为要满足x,y,z的最小公倍数为temp,即p^t必然要至少存在一个,所以max(i,j,k)=t。           

换言之:至少要有一个p^t,以满足lcm的要求;至多有两个包含p,以满足gcd的要求。           

因而基本的组合方式为(0,p^t,p^k),k=0-->t。           

而因为(1,2,3)和(2,1,3)是不同的方法,所有满足要求的方法中,除了(0,0,t)和(0,t,t)各有3种排列之外,其余的(0,x,t)(1<=x<=t-1)有6种排列。           

对于某一个素因子p总的方法数为6*(t-1)+2*3=6*t。   在根据组合排列的知识,素数与素数之间是分步的关系,因而总的方法数为:6*t1*6*t2*6*t3*...*6*tn

题目:

Given two positive integers G and L, could you tell me how many solutions of (x, y, z) there are, satisfying that gcd(x, y, z) = G and lcm(x, y, z) = L? 
Note, gcd(x, y, z) means the greatest common divisor of x, y and z, while lcm(x, y, z) means the least common multiple of x, y and z. 
Note 2, (1, 2, 3) and (1, 3, 2) are two different solutions.

Input

First line comes an integer T (T <= 12), telling the number of test cases. 
The next T lines, each contains two positive 32-bit signed integers, G and L. 
It’s guaranteed that each answer will fit in a 32-bit signed integer.

Output

For each test case, print one line with the number of solutions satisfying the conditions above.

Sample Input

2 
6 72 
7 33 

Sample Output

72 
0

AC代码

#include<iostream>
#include<string.h>
using namespace std;
typedef long long ll;
const int M=1e6+100;
int t,k;
ll m,n;
int book[M],dp[M];
void f()
{
    k=0;
    memset(book,0,sizeof(book));
    memset(dp,0,sizeof(dp));
    for(int i=2; i<M; i++)
        if(!book[i])
        {
            dp[k++]=i;
            for(int j=i<<1; j<M; j+=i)
                book[j]=1;
        }
}
ll dfs(ll x)
{
    ll ant=1;
    for(int i=0; dp[i]<=x&&i<k; i++)/*care 记得i<k,这个条件*/
    {
        if(x%dp[i]==0)
        {
            int a=0;
            while(x%dp[i]==0)
            {
                a++;
                x/=dp[i];
            }
            ant*=6*a;
        }
    }
    if(x>1)
        ant*=6;
    return ant;
}
int main()
{
    cin>>t;
    f();
    while(t--)
    {
        cin>>m>>n;
        if(n%m!=0)
            cout<<"0"<<endl;
        else
        {
            n/=m;
            ll ans=dfs(n);
            cout<<ans<<endl;
        }
    }
    return 0;
}
/*题意:给你三个数x,y,z的最大公约数gcd,最小公倍数lcm . 然后求满足的x,y,z有多少种可能。
(1,3,2) 和 (1,2,3)被视为不同
思路:首先lcm%gcd == 0是必须的,否则无解。然后将tmp = lcm/gcd 进行因式分解。
假设其中有一个质因子p1的幂为e1,那么着三个数中至少有一个为p1^e1,至少有一个为1 。
如果都含有p1的话他就被分到最大公约数里面去了,不会在tmp里面*/

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值